/*
 * IPUpdater.java
 *
 * Created on 29 marzo 2004, 15.41
 */
import java.net.*;
import java.io.*;
/**
 *
 * @author  marzir
 */
public class IPUpdater 
{
    /** Creates a new instance of IPUpdater */
    public IPUpdater() 
    {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) 
    {
            /**
     *       @param args the command line arguments
            */
//        System.out.println(System.getProperty("user.dir"));
        String configURL = ReadConfiguration();
        String Myipstr = RetrieveMyAddress(); //recupero il mio indirizzo IP attuale
        System.out.println("Indirizzo IP: "+ Myipstr);
        String VecchioIP=CatchOldIP(System.getProperty("user.dir") + "\\vecchioip.txt"); //recupero il mio vecchio IP
        System.out.println("Vecchio IP: "+VecchioIP); 
        if ((VecchioIP.compareTo("NOUPDATE")==0)||(Myipstr.compareTo("NOUPDATE")==0)||(configURL.compareTo("NOUPDATE")==0)) // verifico se non ci sono errori gravi
        {
            System.out.println("Problema nell'aggiornamento, verificare 2MyDNS");
        }
        else 
        {    
            if (Myipstr.compareTo(VecchioIP)==0)// verifico che l'indirizzo IP sia cambiato dall'ultimo aggiornamento
            {

                System.out.println("L'indirizzo IP " + Myipstr + " non  cambiato dall'ultima verifica");
            }
            else
            {

                String Myurl = configURL.replaceFirst("<IP>", Myipstr);                    
                System.out.println(Myurl);
                //int esito=0;
                int esito = Myurlupdate(Myurl);
                if (esito == 0) // se l'update  riuscito salvo il mio nuovo indirizzo IP per lengthfuture verifiche
                {
                    UpdateOldIP(System.getProperty("user.dir") + "\\vecchioip.txt", Myipstr);
                }
            }
        }
    }
    
    public static int UpdateOldIP (String nomefile, String nuovoIP)
    {
            /** Routine che aggiorna il file contenente il vecchio IP*/
        try 
        {
            FileWriter nuovoFileVecchioIP = new FileWriter(nomefile);
            nuovoFileVecchioIP.write(nuovoIP);
            nuovoFileVecchioIP.close();
            
        }
        catch (IOException e){}
        return 0;
    }
    
    public static String CatchOldIP (String nomeFile)
    {
         /** Routine che recupera l'indirizzo IP precedentemente allocato*/
        String VecchioIP = "0.0.0.0";
        try {
        FileReader fileVecchioIP = new FileReader(nomeFile);
        BufferedReader inFile = new BufferedReader(fileVecchioIP);
        VecchioIP = inFile.readLine();
        fileVecchioIP.close();
        }
        catch (FileNotFoundException e){VecchioIP=VecchioIP;}
        catch (IOException e){VecchioIP=VecchioIP;}
        return VecchioIP;
    }
    
    public static int Myurlupdate (String address)
    {
         /** Routine che aggiorna L'IP su 2MyDNS*/
           try {
                    URL dnsUpdate = new URL (address);
                    URLConnection dnsUpdateConnection = dnsUpdate.openConnection();
                    BufferedReader in = new BufferedReader( new InputStreamReader (
                    dnsUpdateConnection.getInputStream()));
                    String inputLine;
                    while ( (inputLine=in.readLine())!=null) 
                        {
                        System.out.println(inputLine);
                        }
                    in.close();
                    return 0;
                } 
            catch (MalformedURLException e) 
                    {
                     System.out.println("Malformed URL Exception "+e);
                     return 1;
                    } 
            catch (IOException e ) 
                    {
                    System.out.println("IO Exception "+e);
                    return 1;
                    }
    }
    public static String RetrieveMyAddress()
    {
         /** Routine che recupera l'IP attuale*/
       try {
        URL dnsUpdate = new URL ("http://checkip.dyndns.org/");
        URLConnection dnsUpdateConnection = dnsUpdate.openConnection();
        BufferedReader in = new BufferedReader( new InputStreamReader (
        dnsUpdateConnection.getInputStream()));
        String inputLine;
        String MyIP = "";
        while ( (inputLine=in.readLine())!=null) 
            {
            MyIP = inputLine.substring(76,inputLine.length()-14);
            }
        in.close();
        if (MyIP.matches("(\\d+)(\\.)(\\d+)(\\.)(\\d+)(\\.)(\\d+)"))
        {
           return MyIP; 
        }
        else
        {
            return "NOUPDATE";
        }
        
    } 
catch (MalformedURLException e) 
        {
         System.out.println("Malformed URL Exception "+e);
         return "NOUPDATE";
        } 
catch (IOException e ) 
        {
        System.out.println("IO Exception "+e);
        return "NOUPDATE";
        }
 
    }
    public static String ReadConfiguration()
    {
          /** Routine che legge il file di configurazione di IP updater */
    String URLupdate = "NOUPDATE";
        try { 
            FileReader fileConfig = new FileReader(System.getProperty("user.dir") + "\\IPUpdater.ini");
            BufferedReader inFile = new BufferedReader(fileConfig);
            URLupdate = inFile.readLine();
            URLupdate = URLupdate.substring(URLupdate.lastIndexOf(":==")+3);
            inFile.close();
            return URLupdate;
        }
        catch (FileNotFoundException e){return URLupdate;}
        catch (IOException e){return URLupdate;}
        
    }
        
}
 

